## GstMsdkEnc

    GObject
        ╰──GInitiallyUnowned
            ╰──GstObject
                ╰──GstElement
                    ╰──GstVideoEncoder
                        ╰──GstMsdkEnc

### Properties

#### accuracy

    “accuracy” guint

The AVBR Accuracy in the unit of tenth of percent

Flags : Read / Write

Default value : 0

#### async-depth

    “async-depth” guint

Depth of asynchronous pipeline

Flags : Read / Write

Default value : 4

#### b-adapt

    “b-adapt” Msdk-enc-adaptive-b *

Adaptive B-Frame Insertion control

Flags : Read / Write

Default value : off (32)

#### b-frames

    “b-frames” guint

Number of B frames between I and P frames

Flags : Read / Write

Default value : 0

#### bitrate

    “bitrate” guint

Bitrate in kbit/sec

Flags : Read / Write

Default value : 2048

#### convergence

    “convergence” guint

The AVBR Convergence in the unit of 100 frames

Flags : Read / Write

Default value : 0

#### ext-coding-props

    “ext-coding-props” GstStructure *

The properties for the external coding.

Supported properties:

    extbrc         : External bitrate control
                     String. Range: { auto, on, off } Default: off

Example:

    ext-coding-props="props,extbrc=on"

Flags : Read / Write

Since : 1.20

#### gop-size

    “gop-size” guint

GOP Size

Flags : Read / Write

Default value : 256

#### hardware

    “hardware” gboolean

Enable hardware encoders

Flags : Read / Write

Default value : true

#### i-adapt

    “i-adapt” Msdk-enc-adaptive-i *

Adaptive I-Frame Insertion control

Flags : Read / Write

Default value : off (32)

#### i-frames

    “i-frames” guint

Number of I frames between IDR frames

Flags : Read / Write

Default value : 0

#### max-frame-size

    “max-frame-size” guint

Maximum possible size (in kbyte) of any compressed frames (0: auto-calculate)

Flags : Read / Write

Default value : 0

#### max-vbv-bitrate

    “max-vbv-bitrate” guint

Maximum bitrate(kbit/sec) at which data enters Video Buffering Verifier (0: auto-calculate)

Flags : Read / Write

Default value : 0

#### mbbrc

    “mbbrc” Msdk-enc-mb-bitrate-control *

Macroblock level bitrate control

Flags : Read / Write

Default value : off (32)

#### num-slices

    “num-slices” guint

Number of slices per frame, Zero tells the encoder to choose any slice partitioning allowed by the codec standard

Flags : Read / Write

Default value : 0

#### qpb

    “qpb” guint

Constant quantizer for B frames (0 unlimited)

Flags : Read / Write

Default value : 0

#### qpi

    “qpi” guint

Constant quantizer for I frames (0 unlimited). Also used as ICQQuality or QVBRQuality for different RateControl methods

Flags : Read / Write

Default value : 0

#### qpp

    “qpp” guint

Constant quantizer for P frames (0 unlimited)

Flags : Read / Write

Default value : 0

#### rate-control

    “rate-control” Msdk-enc-rate-control *

Rate control method

Flags : Read / Write

Default value : cbr (1)

#### rc-lookahead

    “rc-lookahead” guint

Number of frames to look ahead for Rate control

Flags : Read / Write

Default value : 10

#### ref-frames

    “ref-frames” guint

Number of reference frames

Flags : Read / Write

Default value : 1

#### target-usage

    “target-usage” guint

1: Best quality, 4: Balanced, 7: Best speed

Flags : Read / Write

Default value : 4

### Named constants

#### Msdk-enc-adaptive-b

##### Members

`auto` (0) – SDK desides what to do
`off` (32) – Disable Adaptive B-Frame insertion
`on` (16) – Enable Aaptive B-Frame insertion

#### Msdk-enc-adaptive-i

##### Members

`auto` (0) – SDK desides what to do
`off` (32) – Disable Adaptive I frame insertion
`on` (16) – Enable Aaptive I frame insertion

#### Msdk-enc-mb-bitrate-control

##### Members

`auto` (0) – SDK desides what to do
`off` (32) – Disable Macroblock level bit rate control
`on` (16) – Enable Macroblock level bit rate control

#### Msdk-enc-rate-control

##### Members

`cbr` (1) – Constant Bitrate
`vbr` (2) – Variable Bitrate
`cqp` (3) – Constant Quantizer
`avbr` (4) – Average Bitrate
`la_vbr` (8) – VBR with look ahead (Non HRD compliant)
`icq` (9) – Intelligent CQP
`vcm` (10) – Video Conferencing Mode (Non HRD compliant)
`la_icq` (11) – Intelligent CQP with LA (Non HRD compliant)
`la_hrd` (13) – HRD compliant LA
`qvbr` (14) – VBR with CQP

The results of the search are